Redmine - Feature #4687

Add copy project permission
2010-01-29 00:48 - Nick Fitzgerald

Status: New Start date: 2010-01-29
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Projects Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution:

Description

With the ability to copy projects, it would be nice to be able to grant permissions to do so. Currently only Redmine administrators can
copy projects. If this permission is added a Copy project link could be added on the Overview tab next to the Add subject link.

Related issues:

Related to Redmine - Patch #25154: Allow non-administrator users to copy cert... New

Has duplicate Redmine - Feature #17961: permissions for copy project Closed

Has duplicate Redmine - Feature #13373: copy a (sub-)project as "non-admin” ... Closed

Has duplicate Redmine - Feature #7118: Possibility to allow users to copy a p... Closed 2010-12-16
History

#1 - 2010-01-29 05:14 - Kyle Corupe

| 2nd this, this feature would be very nice to have. If someone has permission to be able to create a project they should be able to copy one.

#2 - 2010-02-16 15:25 - Harwant Pannu

In my version (0.8.4.stable.2777), only administrators can create new projects. If the latest version allows permission grant to non-Administrators for
creating new projects then the request makes sense. | will suggest the following logic to allow project copy to an individual:

if (user is allowed to create new a projects) AND (user is a manager or something equivalent for this project) then user can copy this
project

This will ensure that both ends are covered, sufficient permissions to the project to copy and permissions to create a new project.
Thanks.

#3 - 2010-03-31 20:16 - Enderson Maia

+1

| really need this one!

#4 - 2010-03-31 20:56 - Enderson Maia

Harwant Pannu wrote:

In my version (0.8.4.stable.2777), only administrators can create new projects. If the latest version allows permission grant to non-Administrators
for creating new projects then the request makes sense. | will suggest the following logic to allow project copy to an individual:

if (user is allowed to create new a projects) AND (user is a manager or something equivalent for this project) then user can copy this
project

This will ensure that both ends are covered, sufficient permissions to the project to copy and permissions to create a new project.

Thanks.

| think both permission could exist, create and copy.

In my case | have a role that can only create sub-projects, and he has this role on a "TOP Project", now I'm using some projects like templates, and |
need a role that can only instantiate this template projects, if | give him a role on this template projects with the copy_project permission, he's able to
create new projects just from copies.

Did | make myself clear ?
#5 - 2010-05-20 12:15 - Pedro Gutierrez

+1

We are creating template projects, but it won't be useful if people can't copy them to create their own projects. As it is now they always have to ask an
administrator to create a copy.

An additional permission for copying would be great.

Pedro

#6 - 2013-07-24 04:34 - Matthew Houston

| know this is an old ticket but there hasn't been any movement. Any chance of this?
#7 - 2013-10-18 23:13 - Riccardo Rocca

+1

Necessary for our teams!

#8 - 2013-11-22 04:23 - David Tremblay

+1 necessary on our side

#9 - 2014-10-31 09:34 - Thibaut Comte
+1

Is there any updates on this feature?

#10 - 2015-02-09 15:11 - Jiirgen Depicker

+1 Any nice soul worked on this?

#11 - 2015-04-16 08:05 - Sebastian Paluch

+1
and duplicated by #13373 and #17961.

#12 - 2015-04-20 16:15 - Go MAEDA

- Has duplicate Feature #17961: permissions for copy project added

#13 - 2015-04-20 16:22 - Go MAEDA

- Has duplicate Feature #13373: copy a (sub-)project as "non-admin" user added

#14 - 2015-06-23 09:43 - Stefan Mischke

+1
Having to start every new project from scratch to me seems quite unagile...

#15 - 2015-11-19 17:35 - noemie bolo

+1
it would be so helpful !l

#16 - 2016-01-27 13:03 - Luis Blasco

+1
Thanks in advance!

#17 - 2016-08-17 13:39 - Maximilian Hackenschmied

+1
Would really save us some time as it removes a bottleneck! Thanks in advance!

#18 - 2016-09-19 16:10 - Stephane Evr

+1

#19 - 2017-02-22 21:14 - Mischa The Evil
- Has duplicate Feature #7118: Possibility to allow users to copy a project added
#20 - 2017-02-22 21:14 - Mischa The Evil

- Related to Patch #25154: Allow non-administrator users to copy certain projects added

#21 - 2017-11-26 12:44 - Eva Encabo

+1 It's a basic function

#22 - 2020-02-19 07:08 - Mizuki ISHIKAWA
- File diff.patch added

| have attached the patch.
Users with copy_project permission can copy from projects/show.

Even if you do not have view_issues permission of the copy source project, you can copy issues from the source project if you have copy_project
permission.

If you change the copied project to public at that time, you will be able to see issues that you would not have permission to see.

That is, the copy_project permission includes various permissions such as view_issues, view_messages, and view_wiki.

| think it is necessary to discuss whether there is a problem with the copy_project authority as the authority design policy.

#23 - 2020-02-29 07:29 - Go MAEDA

- Target version set to Candidate for next major release

#24 - 2020-04-24 08:55 - Markus Gerhold
- File project_copy.patch added

I've attached a patch, similar to the one above, where the user is allowed to copy projects if he has add_project permission. If one is allowed to create
projects he should also be able to copy projects. The current user is also added as default member to the copied project, just like when creating a
project.

#25 - 2021-02-07 08:34 - Go MAEDA

Markus Gerhold wrote:
If one is allowed to create projects he should also be able to copy projects. The current user is also added as default member to the copied
project, just like when creating a project.

| think it would be a security issue if users who have "Create project” permission are allowed to copy a project. This is because the user who has

copied a project can have more permissions if "Role given to a non-admin user who creates a project" (Administration > Settings > Projects) is set.

Depending on the settings, users who copy a project will be able to see information in the destination that they are not allowed to see in the source
project.

#26 - 2021-02-07 08:53 - Go MAEDA
- File 4687-v2.patch added

Updated the patch for the latest trunk (r20739).

#27 - 2021-02-08 05:48 - Go MAEDA

| found an issue in the patch.

When a user attempts to copy a parent project, a validation error "Subproject of is invalid" is shown if the user does not have "Copy project"
permission for subprojects.

| think the "Copy" button for the project should not be shown if the user does not have "Copy project" permission for subprojects.
"Delete project" permission (#33945) behaves like that. If you don't have permission for subprojects, "Delete" button does not appear on the parent.
#28 - 2021-06-03 04:20 - Go MAEDA
Go MAEDA wrote:
| found an issue in the patch.

When a user attempts to copy a parent project, a validation error "Subproject of is invalid" is shown if the user does not have "Copy project”
permission for subprojects.
Steps to reproduce:

1. Apply 4687-v2.patch

2. Load fixtures by running bin/rails db:fixtures:load

3. Grant "Copy project" privilege to Developer role

4. Sign in with the user "dlopper" (password: "foo")

5. Try to copy the project "eCookbook". You will see "Subproject of is invalid" error

#29 - 2022-01-05 12:55 - Markus Boremski
Will there be a day when this kind of basic feature is implemented? ;)

There are a lot of patches out there regarding this..
On every update we have to fiddle out which one works..

Thanks alot..

#30 - 2022-04-12 18:12 - Markus Boremski

Can anyone please adress this for V5.0 please?

#31 - 2022-04-13 04:20 - Mizuki ISHIKAWA
- File 4687-v3.patch added
- File permissions.png added
Go MAEDA wrote:
Go MAEDA wrote:
| found an issue in the patch.
When a user attempts to copy a parent project, a validation error "Subproject of is invalid" is shown if the user does not have "Copy project”

permission for subprojects.

Steps to reproduce:

1. Apply 4687-v2.patch
2. Load fixtures by running bin/rails db:fixtures:load

3. Grant "Copy project" privilege to Developer role
4. Sign in with the user "dlopper" (password: "foo")
5. Try to copy the project "eCookbook". You will see "Subproject of is invalid" error

| have attach a patch that resolves this probrem.

The copy_project permission cannot be enabled unless one of the :add_project or :add_subprojects permissions is enabled.
permissions.png

This patch is under development, so applying it to the production environment is risky.

#32 - 2022-04-14 03:54 - Mizuki ISHIKAWA

- File 4687-v4.patch added

Fix a problem with the disabled attribute of checkboxes.

#33 - 2023-02-07 09:40 - Markus Boremski
- File 4687-v4-for_v4.2.9.patch added

Unfortunately 4687-v4.patch only applies to redmine 5.0.x
| made some changes to make it work on latest 4.2.9.
| also added a German translation.

#34 - 2023-11-06 10:00 - C Glass
4687-v4.patch does not work for Redmine 5.1

Please help to update.

#35 - 2024-02-15 10:34 - Nat D
| identified the modification brought to lib/redmine.rb have to be put in lib/redmine/preparation.rb. (preparation code moved to redmine/preparation.rb (

#29914, #32938))

Unfortunately, as simple user of redmine in my company, | have no chance to implement, test and apply any patch...

#36 - 2024-08-27 16:11 - Markus Boremski
- File 4687-v4_for_v5.1.3.patch added

| managed to fix the patch to work for redmine 5.1.3.
Also added a german translation.

Unfortunately the Button for Copy does not show up in context-menue.

| fiddled aroud a bit with 'app/views/context_menus/projects.html.erb’ and 'app/views/projects/show.html.erb' but could not figure out how to fix.

But if the user (withthe permission to copy) calls /copy one can copy the projekt.

Can someone improve this?
Can we please add this feature to main?

#37 - 2025-03-24 19:22 - C Glass

Hi Markus Schlichting Boremski and all, did you manage to get this patch working for 6.0.4?

| hope some one with the know how helps to get this updated.

Really wish this feature were added to the core.

Files

diff.patch 5.08 KB 2020-02-19 Mizuki ISHIKAWA
project_copy.patch 5.6 KB 2020-04-24 Markus Gerhold
4687-v2.patch 5.01 KB 2021-02-07 Go MAEDA
4687-v3.patch 10.9 KB 2022-04-13 Mizuki ISHIKAWA
permissions.png 120 KB 2022-04-13 Mizuki ISHIKAWA
4687-v4.patch 11.9 KB 2022-04-14 Mizuki ISHIKAWA
4687-v4-for_v4.2.9.patch 12.6 KB 2023-02-07 Markus Boremski
4687-v4_for_v5.1.3.patch 12.2 KB 2024-08-27 Markus Boremski
